function varargout = PlotImage(varargin)
% PLOTIMAGE MATLAB code for PlotImage.fig
%      PLOTIMAGE, by itself, creates a new PLOTIMAGE or raises the existing
%      singleton*.
%
%      H = PLOTIMAGE returns the handle to a new PLOTIMAGE or the handle to
%      the existing singleton*.
%
%      PLOTIMAGE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PLOTIMAGE.M with the given input arguments.
%
%      PLOTIMAGE('Property','Value',...) creates a new PLOTIMAGE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before PlotImage_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to PlotImage_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help PlotImage

% Last Modified by GUIDE v2.5 30-Jun-2016 13:18:16

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @PlotImage_OpeningFcn, ...
                   'gui_OutputFcn',  @PlotImage_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before PlotImage is made visible.
function PlotImage_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to PlotImage (see VARARGIN)

% Choose default command line output for PlotImage
handles.output = hObject;

handles.fysa = varargin{1}; % Add fys object to handles
%update the strings with list of available pictures
set(handles.popmPictures,'string',fieldnames(handles.fysa.pictures));
update_axes(handles);
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes PlotImage wait for user response (see UIRESUME)
% uiwait(handles.figure1);

function update_editboxes(handles);
    set(handles.cLower,'string',handles.axes1.CLim(1));
    set(handles.cUpper,'string',handles.axes1.CLim(2));

function update_axes(handles);
    %Set colormap
    set(0,'DefaultFigureColormap',hot)
    %Get selected picture fieldname
    contents = cellstr(get(handles.popmPictures,'String'));
    picturename = contents{get(handles.popmPictures,'Value')};
    picture = handles.fysa.pictures.(picturename);
    %Remove 0
    picture(~picture) = nan;
    hold(handles.axes1, 'off')
    handles.fysa.handles.im = imagesc(picture, 'parent', handles.axes1);
    f = 2.5;
    m = median(picture(:), 'omitnan');
    s = std(picture(:), 'omitnan');
    ir = iqr(picture(:));
    handles.axes1.CLim = [m-f*ir m+f*ir];
    handles.axes1.XLabel.String = 'X';
    handles.axes1.YLabel.String = 'Y';
    update_editboxes(handles);
    hold(handles.axes1,'on');
    colorbar(handles.axes1);
    %overlay mask
    set(handles.fysa.handles.im, 'AlphaData', handles.fysa.mask)
    % set background neutral Grey
    set(handles.axes1,'color',[0.5 0.5 0.5])
    %Set click function on image
    set(handles.fysa.handles.im,'ButtonDownFcn',@(o,e) ImageClickCallback(o,e,handles));
    display('debug');
    
function ImageClickCallback ( objectHandle , eventData ,handles)
   axesHandle  = get(objectHandle,'Parent');
   coordinates = get(axesHandle,'CurrentPoint'); 
   coordinates = coordinates(1,1:2);
   handles.fysa.selY = round(coordinates(1));
   handles.fysa.selX = round(coordinates(2));
   %display(coordinates);
   %// then here you can use coordinates as you want ...

% --- Outputs from this function are returned to the command line.
function varargout = PlotImage_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popmPictures.
function popmPictures_Callback(hObject, eventdata, handles)
% hObject    handle to popmPictures (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popmPictures contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popmPictures
update_axes(handles);

% --- Executes during object creation, after setting all properties.
function popmPictures_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popmPictures (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pbSave.
function pbSave_Callback(hObject, eventdata, handles)
% hObject    handle to pbSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
filename = uiputfile('*.png');
saveas(handles.axes1,filename,'png')



function edX_Callback(hObject, eventdata, handles)
% hObject    handle to edX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edX as text
%        str2double(get(hObject,'String')) returns contents of edX as a double
handles.fysa.selX = str2double(get(hObject,'String'));

% --- Executes during object creation, after setting all properties.
function edX_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edX (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edY_Callback(hObject, eventdata, handles)
% hObject    handle to edY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edY as text
%        str2double(get(hObject,'String')) returns contents of edY as a double
handles.fysa.selY = str2double(get(hObject,'String'));

% --- Executes during object creation, after setting all properties.
function edY_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edY (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pbPlotFit.
function pbPlotFit_Callback(hObject, eventdata, handles)
% hObject    handle to pbPlotFit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
plotPixel(handles.fysa);


% --- Executes on mouse press over axes background.
function axes1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
display('Clicked');



function cLower_Callback(hObject, eventdata, handles)
% hObject    handle to cLower (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cLower as text
%        str2double(get(hObject,'String')) returns contents of cLower as a double
cLower = str2num(get(handles.cLower,'string'));
cUpper = str2num(get(handles.cUpper,'string'));
handles.axes1.CLim = [cLower cUpper];

% --- Executes during object creation, after setting all properties.
function cLower_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cLower (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cUpper_Callback(hObject, eventdata, handles)
% hObject    handle to cUpper (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cUpper as text
%        str2double(get(hObject,'String')) returns contents of cUpper as a double


% --- Executes during object creation, after setting all properties.
function cUpper_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cUpper (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
